import * as redis from './redis.js'

const cache = {}

export function set (key, value) {
  if (cache[key] === value) return
  cache[key] = value
  if (redis.isEnabled()) {
    return redis.client.set(key, value)
  }
}

export async function getBuffer (key) {
  return get(key, { method: 'getBuffer' })
}

export async function get (key, { method = 'get' } = {}) {
  if (cache[key]) return cache[key]

  if (redis.isEnabled()) {
    const result = await redis.client[method]?.(key)
    cache[key] = result
    return result
  }
}
